/*
** Thierry Roncalli
** Introduction to Risk Parity & Budgeting
**
**> Page 329 (Figure A.7)
**
*/

new;
library rpb,pgraph;

cls;

a = 0.10; b = 0.03; sigma = 0.04;
pi_B = 0.01; D = 10;
pi_S = 0.05; 
sigma_S = 0.20; 
rho = 0.2;

tau = 10; 
gamma_ = 1.5~3~7;

rho = seqa(-0.50,0.01,101);
{x_C,x_B,x_S,params} = Compute_Lifestyle_Portfolio(a,b,sigma,pi_B,D,pi_S,sigma_S,rho,tau,gamma_);
x1 = 100*rho; y1 = 100*x_S;

rho = 0.20;
sigma_S = seqa(0.10,0.01,21); 
{x_C,x_B,x_S,params} = Compute_Lifestyle_Portfolio(a,b,sigma,pi_B,D,pi_S,sigma_S,rho,tau,gamma_);
x2 = 100*sigma_S; y2 = 100*x_S;

sigma_S = 0.20;
gamma_ = 1.5~3~7;
pi_S = seqa(0.01,0.01,81);
{x_C,x_B,x_S,params} = Compute_Lifestyle_Portfolio(a,b,sigma,pi_B,D,pi_S,sigma_S,rho,tau,gamma_);
x3 = 100*pi_S; y3 = 100*x_S;

pi_S = 0.05;
a = seqa(0.01,0.01,100);
{x_C,x_B,x_S,params} = Compute_Lifestyle_Portfolio(a,b,sigma,pi_B,D,pi_S,sigma_S,rho,tau,gamma_);
x4 = 100*a; y4 = 100*x_S;

graphset;
  begwind;
  window(2,2,0);

  fonts("simplex simgrma");
  _pdate = ""; _pnum = 2; _pframe = 0;
  _paxht = 0.20; _pnumht = 0.20; _ptitlht = 0.25;
  _pltype = 6|3|1; _plwidth = 10; _pcolor = 1;
  ytics(0,100,20,2);

  setwind(1);
    _pcolor = 1|4|3;
    xlabel("\216\202r\201]S,B[ (in %)");
    xtics(-50,50,25,2);
    xy(x1,y1);

  setwind(2);
    _pcolor = 1|4|3;
    xlabel("\216\202s\201]S[ (in %)");
    xtics(10,30,5,2);
    xy(x2,y2);

  setwind(3);
    xlabel("\216\202p\201]S[ (in %)");
    xtics(1,8,1,2);
    xy(x3,y3);
  
  setwind(4);
    xlabel("\216a (in %)");
    xtics(0,100,20,2);
    _plegstr = "\202g\201 = 1.5\000\202g\201 = 3\000\202g\201 = 7";
    _plegctl = {2 6 2.4 3.65};
    xy(x4,y4);

    graphprt("-c=1 -cf=app1-3-3-3.eps");

  endwind;
