/*
** Thierry Roncalli
** Introduction to Risk Parity & Budgeting
**
**> Page 368 (Exercise B.3.6)
**
*/

new;
library rpb,pgraph;

cls;

/*
**> Question 1
**
*/

print;
print "=====================  Question 1.a  =======================================";

let Spread = 79 42 179 267;
let sigma_S = 57 49 61 59;
let rho_S =   100                                                    
               65              100                                   
               67               70              100                  
               64               67               83              100;
rho_S = xpnd(rho_S);

Spread = Spread / 1e4;
sigma_S = sigma_S / 1e2;
rho_S = rho_S / 1e2;

let x1 = 10    12     8       7;
let D1 = 6.2   7.5    6.4     5.8;

sigma_c = D1 .* Sigma_S .* Spread;
print ftosa(x1~D1~100*sigma_c,"%lf",3,2);

cov = rho_S .* sigma_c .* sigma_c';
R1 = sqrt(x1'cov*x1);

{vol1,mr1,rc1,prc1} = Compute_Risk_Contribution(x1,cov);

print ftosa(x1,"%lf",3,0)$~ftosa(mr1,"%lf",3,3)$~ftosa(rc1,"%lf",3,3)$~ftosa(100*prc1,"%lf",3,1);
print ftosa(R1,"R = %lf",3,3);

print;
print "=====================  Question 1.b  =======================================";

let x2 = 8    8     12    14;
let D2 = 7.1  6.9   6.5   8.3;

sigma_c = D2 .* Sigma_S .* Spread;
print ftosa(x2~D2~100*sigma_c,"%lf",3,2);

cov = rho_S .* sigma_c .* sigma_c';
R2 = sqrt(x2'cov*x2);

{vol2,mr2,rc2,prc2} = Compute_Risk_Contribution(x2,cov);

print ftosa(x2,"%lf",3,0)$~ftosa(mr2,"%lf",3,3)$~ftosa(rc2,"%lf",3,3)$~ftosa(100*prc2,"%lf",3,1);
print ftosa(R2,"R = %lf",3,3);

print;
print "=====================  Question 1.c  =======================================";

let indx = 1 2 3 4 1 2 3 4;
Spread3 = Spread | Spread;
sigma_S3 = sigma_S | sigma_S;
let rho_S4 =   100                                                    
               65              100                                   
               67               70              100                  
               64               67               83              100
               100              65               67               64           100                                  
               65              100               70               67            65         100                  
               67               70              100               83            67          70         100
               64               67               83              100            64          67          83         100; 
rho_S4 = xpnd(rho_S4);

rho_S3 = zeros(8,8);
i = 1;
do until i > 8;
  j = 1;
  do until j > 8;
    if i == j;
      rho_S3[i,j] = 1.0;
    else;
      if indx[i] == indx[j];
        rho_S3[i,j] = 1.0;
      else;
        rho_S3[i,j] = rho_S[indx[i],indx[j]];
      endif;
    endif;
    j = j + 1;
  endo;
  i = i + 1;
endo;

print ftosa(rho_S4,"%lf",3,0);
print ftosa(rho_S3,"%lf",3,2);
print ftosa(rho_S4-100*rho_S3,"%lf",3,0);

D3 = D1 | D2;
x3 = x1 | x2;

sigma_c = D3 .* Sigma_S3 .* Spread3;
print ftosa(x3~D3~100*sigma_c,"%lf",3,2);

cov = rho_S3 .* sigma_c .* sigma_c';
R3 = sqrt(x3'cov*x3);

{vol3,mr3,rc3,prc3} = Compute_Risk_Contribution(x3,cov);
result = (x3~mr3~rc3~100*prc3)|(error(0)~error(0)~R3~error(0));

print ftosa(x3,"%lf",3,0)$~ftosa(mr3,"%lf",3,3)$~ftosa(rc3,"%lf",3,3)$~ftosa(100*prc3,"%lf",3,1);
print ftosa(R3,"R = %lf",3,3);

result = (x3~mr3~rc3~prc3);
Result = Result[1:4,.]+Result[5:8,.];
Result = Result |
         (error(0)~error(0)~R3~error(0));

print ftosa(Result[.,1],"%lf",3,0)$~ftosa(Result[.,2],"%lf",3,3)$~ftosa(Result[.,3],"%lf",3,3)$~ftosa(100*Result[.,4],"%lf",3,1);

y1 = x1 | zeros(4,1);
y2 = zeros(4,1) | x2;
vol_y1 = sqrt(y1'cov*y1);
vol_y2 = sqrt(y2'cov*y2);
rho_y1_y2 = (y1'cov*y2)/(vol_y1*vol_y2);
print ftosa(100*rho_y1_y2,"rho(x1,x2) = %lf",3,2);

print;
print "=====================  Question 1.d  =======================================";

let indx = 1 1 2 2 3 3 4 4;
Spread4 = vecr(Spread ~ Spread);
sigma_S4 = vecr(sigma_S ~ sigma_S);
rho_S4 = zeros(8,8);
i = 1;
do until i > 8;
  j = 1;
  do until j > 8;
    if i == j;
      rho_S4[i,j] = 1.0;
    else;
      if indx[i] == indx[j];
        rho_S4[i,j] = 1.0;
      else;
        rho_S4[i,j] = rho_S[indx[i],indx[j]];
      endif;
    endif;
    j = j + 1;
  endo;
  i = i + 1;
endo;

// print ftosa(100*rho_S4,"%lf",3,0);

D4 = vecr(D1 ~ D2);
x4 = vecr(x1 ~ x2);

sigma_c = D4 .* Sigma_S4 .* Spread4;
cov = rho_S4 .* sigma_c .* sigma_c';
R4 = sqrt(x4'cov*x4);

{vol4,mr4,rc4,prc4} = Compute_Risk_Contribution(x4,cov);

print ftosa(x4,"%lf",3,0)$~ftosa(mr4,"%lf",3,3)$~ftosa(rc4,"%lf",3,3)$~ftosa(100*prc4,"%lf",3,1);
print ftosa(R4,"R = %lf",3,3);

result = (x4~mr4~rc4~prc4);
Result = Result[1 3 5 7,.] + Result[2 4 6 8,.];
Result = Result |
         (error(0)~error(0)~R4~error(0));

print ftosa(Result[.,1],"%lf",3,0)$~ftosa(Result[.,3],"%lf",3,3)$~ftosa(100*Result[.,4],"%lf",3,1);

print;
print "=====================  Question 1.e  =======================================";

x5 = x1 + x2;
D5 = (x1 .* D1 + x2 .* D2) ./ (x1 + x2);
print ftosa(D5,"%lf",3,3);

sigma_c = D5 .* Sigma_S .* Spread;
cov5 = rho_S .* sigma_c .* sigma_c';
{vol5,mr5,rc5,prc5} = Compute_Risk_Contribution(x5,cov5);
R5 = sumc(rc5);

print ftosa(x5,"%lf",3,0)$~ftosa(D5,"%lf",3,3)$~ftosa(mr5,"%lf",3,3)$~ftosa(rc5,"%lf",3,3)$~ftosa(100*prc5,"%lf",3,1);
print ftosa(R5,"R = %lf",3,3);

/*
**> Question 2
**
*/

let b = 0.20 0.20 0.30 0.30;

print;
print "=====================  Question 2.a  =======================================";

let Spread = 79 42 179 267;
let sigma_S = 57 49 61 59;
let rho_S =   100                                                    
               65              100                                   
               67               70              100                  
               64               67               83              100;
rho_S = xpnd(rho_S);

Spread = Spread / 1e4;
sigma_S = sigma_S / 1e2;
rho_S = rho_S / 1e2;

let D1 = 6.2   7.5    6.4     5.8;
sigma_c = D1 .* Sigma_S .* Spread;
cov = rho_S .* sigma_c .* sigma_c';

{x1,R1,mr1,rc1,prc1} =  Compute_RB_Portfolio(0,cov,b);
y1 = x1 * 37;
{vol1,mr1,rc1,prc1} = Compute_Risk_Contribution(y1,cov);

print ftosa(y1,"%lf",3,2)$~ftosa(mr1,"%lf",3,3)$~ftosa(rc1,"%lf",3,3)$~ftosa(100*prc1,"%lf",3,1);
print ftosa(vol1,"R = %lf",3,3);

print;
print "=====================  Question 2.b  =======================================";

let D2 = 7.1  6.9   6.5   8.3;
sigma_c = D2 .* Sigma_S .* Spread;
cov = rho_S .* sigma_c .* sigma_c';

{x2,R2,mr2,rc2,prc2} =  Compute_RB_Portfolio(0,cov,b);
y2 = x2 * 42;
{vol2,mr2,rc2,prc2} = Compute_Risk_Contribution(y2,cov);

print ftosa(y2,"%lf",3,2)$~ftosa(mr2,"%lf",3,3)$~ftosa(rc2,"%lf",3,3)$~ftosa(100*prc2,"%lf",3,1);
print ftosa(vol2,"R = %lf",3,3);

print;
print "=====================  Question 2.d  =======================================";

y3 = y1 | y2;

let indx = 1 2 3 4 1 2 3 4;
Spread3 = Spread | Spread;
sigma_S3 = sigma_S | sigma_S;
rho_S3 = zeros(8,8);
i = 1;
do until i > 8;
  j = 1;
  do until j > 8;
    if i == j;
      rho_S3[i,j] = 1.0;
    else;
      if indx[i] == indx[j];
        rho_S3[i,j] = 1.0;
      else;
        rho_S3[i,j] = rho_S[indx[i],indx[j]];
      endif;
    endif;
    j = j + 1;
  endo;
  i = i + 1;
endo;
D3 = D1 | D2;

sigma_c = D3 .* Sigma_S3 .* Spread3;
cov = rho_S3 .* sigma_c .* sigma_c';

{vol3,mr3,rc3,prc3} = Compute_Risk_Contribution(y3,cov);

print ftosa(y3,"%lf",3,2)$~ftosa(mr3,"%lf",3,3)$~ftosa(rc3,"%lf",3,3)$~ftosa(100*prc3,"%lf",3,1);
print ftosa(vol3,"R = %lf",3,3);

result = (y3~mr3~rc3~prc3);
Result = Result[1:4,.] + Result[5:8,.];
Result = Result |
         (error(0)~error(0)~vol3~error(0));

print ftosa(Result[.,1],"%lf",3,2)$~ftosa(Result[.,3],"%lf",3,3)$~ftosa(100*Result[.,4],"%lf",3,1);

print;
print "=====================  Question 2.d  =======================================";

let x1 = 10    12     8       7;
let x2 = 8    8     12    14;

D4 = (x1 .* D1 + x2 .* D2) ./ (x1 + x2);

sigma_c = D4 .* Sigma_S .* Spread;
cov = rho_S .* sigma_c .* sigma_c';

{x4,R4,mr4,rc4,prc4} =  Compute_RB_Portfolio(0,cov,b);

y4 = x4 * sumc(x1 + x2);
{vol4,mr4,rc4,prc4} = Compute_Risk_Contribution(y4,cov);

print ftosa(y4,"%lf",3,2)$~ftosa(mr4,"%lf",3,3)$~ftosa(rc4,"%lf",3,3)$~ftosa(100*prc4,"%lf",3,1);
print ftosa(vol4,"R = %lf",3,3);

w = x1 ./ (x1+x2);
y4 = y4 .* w | y4 .* (1-w);

let indx = 1 2 3 4 1 2 3 4;
Spread4 = Spread | Spread;
sigma_S4 = sigma_S | sigma_S;
rho_S4 = zeros(8,8);
i = 1;
do until i > 8;
  j = 1;
  do until j > 8;
    if i == j;
      rho_S4[i,j] = 1.0;
    else;
      if indx[i] == indx[j];
        rho_S4[i,j] = 1.0;
      else;
        rho_S4[i,j] = rho_S[indx[i],indx[j]];
      endif;
    endif;
    j = j + 1;
  endo;
  i = i + 1;
endo;
D4 = D1 | D2;

sigma_c = D4 .* Sigma_S4 .* Spread4;
cov = rho_S4 .* sigma_c .* sigma_c';
R4 = sqrt(y4'cov*y4);

{vol4,mr4,rc4,prc4} = Compute_Risk_Contribution(y4,cov);
result = (y4~mr4~rc4~100*prc4)|(error(0)~error(0)~R4~error(0));

print ftosa(y4,"%lf",3,2)$~ftosa(mr4,"%lf",3,3)$~ftosa(rc4,"%lf",3,3)$~ftosa(100*prc4,"%lf",3,1);
print ftosa(R4,"R = %lf",3,3);

result = (y4~mr4~rc4~prc4);
Result = Result[1:4,.]+Result[5:8,.];
Result = Result |
         (error(0)~error(0)~R4~error(0));

print ftosa(Result[.,1],"%lf",3,2)$~ftosa(Result[.,2],"%lf",3,3)$~ftosa(Result[.,3],"%lf",3,3)$~ftosa(100*Result[.,4],"%lf",3,1);

print;
print "=====================  Question 2.e  =======================================";

let sigma = 0.15 0.20 0.25 0.30 0.20;
let rho = 1.0
          0.5 1.0
          0.1 0.8 1.0
          0.3 0.2 0.4 1.0;
rho = xpnd(rho);
call invpd(rho);
rho = (rho | rho[4,.]) ~ (rho[.,4] | 1.0);

n = 5;
cov = rho[1:n,1:n] .* sigma[1:n] .* sigma[1:n]';
n = 4;
sigma_prime = sigma;
rho_prime = rho;

let x = 0.20 0.30 0.10 0.10 0.30;
{vol_x,mr_x,rc_x,prc_x} = Compute_Risk_Contribution(x,cov);
Results = x~mr_x~rc_x~prc_x | (error(0)~error(0)~vol_x~error(0));

print ftosa(100*Results,"%lf",3,2);

sigma_prime[n] = sigma[n] + sigma[n+1];
y = x;
y[n] = (x[n] * sigma[n] + x[n+1] * sigma[n+1])/(sigma[n] + sigma[n+1]);
cov_prime = rho_prime[1:n,1:n] .* sigma_prime[1:n] .* sigma_prime[1:n]';
y = y[1:n];

{vol_y,mr_y,rc_y,prc_y} = Compute_Risk_Contribution(y,cov_prime);
Results = y~sigma_prime[1:n]~mr_y~rc_y~prc_y | (error(0)~error(0)~error(0)~vol_y~error(0));

print ftosa(100*Results,"%lf",3,2);

y = x;
y[n] = x[n] + x[n+1];
sigma_prime[n] = (x[n] * sigma[n] + x[n+1] * sigma[n+1])/(x[n] + x[n+1]);

cov_prime = rho_prime[1:n,1:n] .* sigma_prime[1:n] .* sigma_prime[1:n]';
y = y[1:n];

{vol_y,mr_y,rc_y,prc_y} = Compute_Risk_Contribution(y,cov_prime);
Results = y~sigma_prime[1:n]~mr_y~rc_y~prc_y | (error(0)~error(0)~error(0)~vol_y~error(0));

print ftosa(100*Results,"%lf",3,2);

y[n] = 0.80;
sigma_prime[n] = (x[n] * sigma[n] + x[n+1] * sigma[n+1])/y[n];

cov_prime = rho_prime[1:n,1:n] .* sigma_prime[1:n] .* sigma_prime[1:n]';
y = y[1:n];

{vol_y,mr_y,rc_y,prc_y} = Compute_Risk_Contribution(y,cov_prime);
Results = y~sigma_prime[1:n]~mr_y~rc_y~prc_y | (error(0)~error(0)~error(0)~vol_y~error(0));

print ftosa(100*Results,"%lf",3,2);

/*
**> Question 3
**
*/

let Spread = 79 42 179 267;
let sigma_S = 57 49 61 59;
let rho_S =   100                                                    
               65              100                                   
               67               70              100                  
               64               67               83              100;
rho_S = xpnd(rho_S);

Spread = Spread / 1e4;
sigma_S = sigma_S / 1e2;
rho_S = rho_S / 1e2;

let D1 = 6.2   7.5    6.4     5.8;
sigma_c = D1 .* Sigma_S .* Spread;
cov = rho_S .* sigma_c .* sigma_c';

let b = 0.20 0.20 0.30 0.30;

print;
print "=====================  Question 3.a  =======================================";

{x1,R1,mr1,rc1,prc1} =  Compute_RB_Portfolio(0,cov,b);
y1 = x1 * 37;
{vol1,mr1,rc1,prc1} = Compute_Risk_Contribution(y1,cov);

print ftosa(y1,"%lf",3,2)$~ftosa(mr1,"%lf",3,3)$~ftosa(rc1,"%lf",3,3)$~ftosa(100*prc1,"%lf",3,1);
print ftosa(vol1,"R = %lf",3,3);

print;
print "=====================  Question 3.b  =======================================";

let D2 = 7.1  6.9   6.5   8.3;
sigma_c = D2 .* Sigma_S .* Spread;
cov = rho_S .* sigma_c .* sigma_c';

{x2,R2,mr2,rc2,prc2} =  Compute_RB_Portfolio(0,cov,b);
y2 = x2 * 42;
{vol2,mr2,rc2,prc2} = Compute_Risk_Contribution(y2,cov);

print ftosa(y2,"%lf",3,2)$~ftosa(mr2,"%lf",3,3)$~ftosa(rc2,"%lf",3,3)$~ftosa(100*prc2,"%lf",3,1);
print ftosa(vol2,"R = %lf",3,3);

print;
print "=====================  Question 3.d  =======================================";

y3 = y1 | y2;

let indx = 1 2 3 4 1 2 3 4;
Spread3 = Spread | Spread;
sigma_S3 = sigma_S | sigma_S;
rho_S3 = zeros(8,8);
i = 1;
do until i > 8;
  j = 1;
  do until j > 8;
    if i == j;
      rho_S3[i,j] = 1.0;
    else;
      if indx[i] == indx[j];
        rho_S3[i,j] = 1.0;
      else;
        rho_S3[i,j] = rho_S[indx[i],indx[j]];
      endif;
    endif;
    j = j + 1;
  endo;
  i = i + 1;
endo;
D3 = D1 | D2;

sigma_c = D3 .* Sigma_S3 .* Spread3;
cov = rho_S3 .* sigma_c .* sigma_c';

{vol3,mr3,rc3,prc3} = Compute_Risk_Contribution(y3,cov);

print ftosa(y3,"%lf",3,2)$~ftosa(mr3,"%lf",3,3)$~ftosa(rc3,"%lf",3,3)$~ftosa(100*prc3,"%lf",3,1);
print ftosa(vol3,"R = %lf",3,3);

result = (y3~mr3~rc3~prc3);
Result = Result[1:4,.] + Result[5:8,.];
Result = Result |
         (error(0)~error(0)~vol3~error(0));

print ftosa(Result[.,1],"%lf",3,2)$~ftosa(Result[.,3],"%lf",3,3)$~ftosa(100*Result[.,4],"%lf",3,1);

print;
print "=====================  Question 3.d  =======================================";

let x1 = 10    12     8       7;
let x2 = 8    8     12    14;

D4 = (x1 .* D1 + x2 .* D2) ./ (x1 + x2);

sigma_c = D4 .* Sigma_S .* Spread;
cov = rho_S .* sigma_c .* sigma_c';

{x4,R4,mr4,rc4,prc4} =  Compute_RB_Portfolio(0,cov,b);
y4 = x4 * sumc(x1+x2);
{vol4,mr4,rc4,prc4} = Compute_Risk_Contribution(y4,cov);

print ftosa(y4,"%lf",3,2)$~ftosa(mr4,"%lf",3,3)$~ftosa(rc4,"%lf",3,3)$~ftosa(100*prc4,"%lf",3,1);
print ftosa(vol4,"R = %lf",3,3);

w = x1 ./ (x1+x2);
y4 = y4 .* w | y4 .* (1-w);

let indx = 1 2 3 4 1 2 3 4;
Spread4 = Spread | Spread;
sigma_S4 = sigma_S | sigma_S;
rho_S4 = zeros(8,8);
i = 1;
do until i > 8;
  j = 1;
  do until j > 8;
    if i == j;
      rho_S4[i,j] = 1.0;
    else;
      if indx[i] == indx[j];
        rho_S4[i,j] = 1.0;
      else;
        rho_S4[i,j] = rho_S[indx[i],indx[j]];
      endif;
    endif;
    j = j + 1;
  endo;
  i = i + 1;
endo;
D4 = D1 | D2;

sigma_c = D4 .* Sigma_S4 .* Spread4;
cov = rho_S4 .* sigma_c .* sigma_c';
R4 = sqrt(y4'cov*y4);

{vol4,mr4,rc4,prc4} = Compute_Risk_Contribution(y4,cov);
result = (y4~mr4~rc4~100*prc4)|(error(0)~error(0)~R4~error(0));

print ftosa(y4,"%lf",3,2)$~ftosa(mr4,"%lf",3,3)$~ftosa(rc4,"%lf",3,3)$~ftosa(100*prc4,"%lf",3,1);
print ftosa(R4,"R = %lf",3,3);

result = (y4~mr4~rc4~prc4);
Result = Result[1:4,.]+Result[5:8,.];
Result = Result |
         (error(0)~error(0)~R4~error(0));

print ftosa(Result[.,1],"%lf",3,2)$~ftosa(Result[.,2],"%lf",3,3)$~ftosa(Result[.,3],"%lf",3,3)$~ftosa(100*Result[.,4],"%lf",3,1);







