/*
** Thierry Roncalli
** Introduction to Risk Parity & Budgeting
**
**> Page 64
**
*/

new;
library rpb,pgraph;

cls;

FileName = "spx-june-2012";

factor = 1;

PathName = "data\\";
datFileName = PathName $+ FileName;

loadm num_data = ^datFileName;
index_cov = factor * xpnd(vread(num_data,"cov"));
index_weights = vread(num_data,"weights");

loads num_data = ^datFileName;
index_tickers = num_data[.,1];
index_names = num_data[.,3];

index_weights = index_weights/sumc(index_weights);

rndseed 123;
n = rows(index_Weights);
indx_mu = zeros(n,1);

x1 = zeros(n,n);
te1 = zeros(n,1);
size1 = zeros(n,1);
order1 = zeros(n,1);
active1 = ones(n,1);

var = sqrt(index_weights'index_cov*index_weights);

sv = index_weights;

i = 1;
do until i > n;

  {x1[.,i],mu_x1,te1[i],gamma_x,retcode} = Compute_Sampling_Portfolio(index_weights,indx_mu,index_cov,0,0,0,0,0,active1);

  y = miss(x1[.,i],0);
  indx = minindc(y);
  size1[i] = sumc(x1[.,i] ./= 0);
  order1[i] = indx;
  active1[indx] = 0;

  sv = x1[.,i];

  i = i + 1;
endo;

FileName = "results\\sampling-spx-june-2012";
data = size1~te1;

save ^FileName = data;
