/*
** Thierry Roncalli
** Introduction to Risk Parity & Budgeting
**
**> Page 84 (Tables 2.5 & 2.6)
**
*/

new;
library rpb,pgraph;

cls;

let sigma = 0.30 0.20 0.15;
let rho = 1.00
          0.80 1.00
          0.50 0.30 1.00;
rho = xpnd(rho);
cov = rho .* sigma .* sigma';

let x = 0.50 0.20 0.30;
{vol,mr,rc,prc} = Compute_RC_Vol(x,cov);

x0 = x;
vol0 = vol;

h = 1/100;
x = x0;
x[1] = x[1] + h;
vol = sqrt(x'cov*x);
dVol = (Vol - Vol0)/h;
print ftosa(100*Vol,"vol = %lf",3,4);
print ftosa(100*dVol,"mr = %lf",3,4);

h = 0.1/100;
x = x0;
x[1] = x[1] + h;
vol = sqrt(x'cov*x);
dVol = (Vol - Vol0)/h;
print ftosa(100*Vol,"vol = %lf",3,4);
print ftosa(100*dVol,"mr = %lf",3,4);

h = 0.01/100;
x = x0;
x[1] = x[1] + h;
vol = sqrt(x'cov*x);
dVol = (Vol - Vol0)/h;
print ftosa(100*Vol,"vol = %lf",3,4);
print ftosa(100*dVol,"mr = %lf",3,4);

let h = 0.01 0.1 1 10 50 -50;
h = h/100;

Result1 = zeros(3,6);
Result2 = zeros(3,6);

i = 1;
do until i > 3;
  j = 1;
  do until j > 6;
    if j == 6;
      h[j] = -x0[i];
    endif;
    x = x0;
    x[i] = x[i] + h[j];
    vol = sqrt(x'cov*x);
    result1[i,j] = vol;
    dVol = mr[i] * h[j];
    result2[i,j] = vol0 + dVol;
    j = j + 1;
  endo;
  i = i + 1;
endo;

print ftosa(100*Result1,"%lf",3,4);
print ftosa(100*Result2,"%lf",3,4);
