/*
** Thierry Roncalli
** Introduction to Risk Parity & Budgeting
**
**> Pages 99-100 (Tables 2.9 & 2.10)
**
*/

new;
library rpb,pgraph;

cls;

_rpb_CCD_tol = 1e-15;
_rpb_algorithm = 1;

let mu =    0.10 0.05 0.09;
let sigma = 0.30 0.20 0.15;
let rho = 1.00
          0.80 1.00
          0.50 0.30 1.00;
rho = xpnd(rho);
cov = rho .* sigma .* sigma';

x0 = ones(3,1)/3;

let b = 0.50 0.20 0.30;
ES = 500000;

alpha = 0.95;
{x,risk,mr,rc,prc} = Compute_RB_ES(x0,mu,cov,alpha,b);
Nominal = ES / risk;
x = nominal * x;
{risk,mr,rc,prc} = Compute_RC_ES(x,mu,cov,alpha);
result1 = (x~100*(x/sumc(x))~100*mr~rc~100*prc)|(sumc(x)~error(0)~error(0)~risk~error(0));

alpha = 0.99;
{x,risk,mr,rc,prc} = Compute_RB_ES(x0,mu,cov,alpha,b);
Nominal = ES / risk;
x = nominal * x;
{risk,mr,rc,prc} = Compute_RC_ES(x,mu,cov,alpha);
result2 = (x~100*(x/sumc(x))~100*mr~rc~100*prc)|(sumc(x)~error(0)~error(0)~risk~error(0));

print "------------------------------------------";
print ftosa(result1,"%lf",3,2);

print "------------------------------------------";
print ftosa(result2,"%lf",3,2);
