/*
** Thierry Roncalli
** Introduction to Risk Parity & Budgeting
**
**> Page 163 (Figure 3.3)
**
*/

new;
library rpb,pgraph;

cls;

sigma1 = 0.20;
sigma2 = 0.22~0.20~0.20~0.16~0.16~0.16;
sigma1 = sigma1 - 0.02;
sigma2 = sigma2 - 0.02;

rho = 0.95~0.90~0.75~0.90~0.75~0.25;
alpha = seqa(0,0.01,101);

sigma = sqrt((1-alpha)^2 * sigma1^2 + alpha^2 * sigma2^2 + 2 .* (1-alpha) .* alpha .* rho .* sigma1 .* sigma2);

graphset;
  fonts("simplex simgrma");
  _pdate = ""; _pnim = 2; _pframe = 0;
  _pnum = 2;
  _pltype = 6|6|1|6|1|3; _plwidth = 10; _pcolor = 0|1|2|3|4|5;
  let xlab = "" "0" "10" "20" "30" "40" "50" "60" "70" "80" "90" "100" "";
  asclabel(xlab,0);
  xtics(-0.1,1.1,0.1,2);
  ytics(11,21,1,2);
  xlabel("\216\201w (in %)\201");
  ylabel("\216Volatility (in %)");
  _psym = 0~18~8~4~0~1~10 |
          1~20~8~4~0~1~10 |
          1~18~8~4~0~1~10 |
          1~14~8~4~0~1~10 ;
  _plegstr = "\202s\201]AW[ = 20%, \202r\201 = 95%\000"\
             "\202s\201]AW[ = 18%, \202r\201 = 90%\000"\
             "\202s\201]AW[ = 18%, \202r\201 = 75%\000"\
             "\202s\201]AW[ = 14%, \202r\201 = 90%\000"\
             "\202s\201]AW[ = 14%, \202r\201 = 75%\000"\
             "\202s\201]AW[ = 14%, \202r\201 = 25%";
  _pmsgstr = "CW Index\000AW Index";
  _pmsgctl = -0.08~18.4~0.19~0~1~0~8 |
              0.90~18.4~0.19~0~1~0~8 ;
  _plegctl = {2 5 1.5 1.25};
  graphprt("-c=1 -cf=chap3-2-3-1.eps");
  xy(alpha,100*sigma);
