/*
** Thierry Roncalli
** Introduction to Risk Parity & Budgeting
**
**> Page 215 (Tables 4.8 & 4.9)
**
*/

new;
library rpb,pgraph;

cls;

let x = 0.20 0.30 0.10 0.15 0.25;
let T = 5    6    8    7    5   ;
let lambda = 100 120 85 115 250;
lambda = lambda/1e4;
p = 1 - exp(-lambda .* T);
let mu_G = 0.70 0.70 0.50 0.50 0.50;

print ftosa(100*x~T~1e4*lambda~100*p~100*mu_G,"%lf",3,2);

rho = 0.30;
alpha = 0.99;
{VaR,RC_VaR,ES,RC_ES} = Compute_RC_Credit(x,mu_G,p,rho,alpha);
Results = (RC_VaR/VaR)~(RC_ES/ES);
Results = Results | (VaR~ES);
Result1 = Results;

rho = 0.50;
alpha = 0.99;
{VaR,RC_VaR,ES,RC_ES} = Compute_RC_Credit(x,mu_G,p,rho,alpha);
Results = (RC_VaR/VaR)~(RC_ES/ES);
Results = Results | (VaR~ES);
Result2 = Results;

rho = 0.30;
alpha = 0.999;
{VaR,RC_VaR,ES,RC_ES} = Compute_RC_Credit(x,mu_G,p,rho,alpha);
Results = (RC_VaR/VaR)~(RC_ES/ES);
Results = Results | (VaR~ES);
Result3 = Results;

print ftosa(100*(Result1~Result2~Result3),"%lf",3,1);
print;
print ftosa(x'mu_G,"Maximum loss = %lf",3,2);
